itpp::Channel_Code Class Referenceabstract
Communications Module » Forward Error Correcting Codes

Generic Channel Code class. More...

`#include <itpp/comm/channel_code.h>`

Inheritance diagram for itpp::Channel_Code:

## Public Member Functions

| Channel_Code ()
| Default constructor.
virtual | ~Channel_Code ()
| Destructor.
virtual void | encode (const bvec &uncoded_bits, bvec &coded_bits)=0
| Encode a bvec of input.
virtual bvec | encode (const bvec &uncoded_bits)=0
| Encode a bvec of input.
virtual void | decode (const bvec &codedbits, bvec &decoded_bits)=0
| Decode a bvec of coded data.
virtual bvec | decode (const bvec &coded_bits)=0
| Decode a bvec of coded data.
virtual void | decode (const vec &received_signal, bvec &decoded_bits)=0
| Decode a vec of received data.
virtual bvec | decode (const vec &received_signal)=0
| Decode a vec of received data.
virtual double | get_rate () const =0
| Get the code rate.

## Detailed Description

Generic Channel Code class.

Definition at line 50 of file channel_code.h.

## Constructor & Destructor Documentation

## Channel_Code()

itpp::Channel_Code::Channel_Code | ( |  | ) |

inline

Default constructor.

Definition at line 54 of file channel_code.h.

## ~Channel_Code()

virtual itpp::Channel_Code::~Channel_Code | ( |  | ) |

inline virtual

Destructor.

Definition at line 56 of file channel_code.h.

## Member Function Documentation

## encode() [1/2]

virtual void itpp::Channel_Code::encode | ( | const bvec & | uncoded_bits,
|  | bvec & | coded_bits
| ) |  |

pure virtual

Encode a bvec of input.

Implemented in itpp::Convolutional_Code, itpp::LDPC_Code, itpp::Punctured_Convolutional_Code, itpp::BCH, itpp::Dummy_Code, itpp::Extended_Golay, itpp::Hamming_Code, and itpp::Reed_Solomon.

## encode() [2/2]

virtual bvec itpp::Channel_Code::encode | ( | const bvec & | uncoded_bits | ) |

pure virtual

Encode a bvec of input.

Implemented in itpp::Convolutional_Code, itpp::LDPC_Code, itpp::Punctured_Convolutional_Code, itpp::BCH, itpp::Dummy_Code, itpp::Extended_Golay, itpp::Hamming_Code, and itpp::Reed_Solomon.

## decode() [1/4]

virtual void itpp::Channel_Code::decode | ( | const bvec & | codedbits,
|  | bvec & | decoded_bits
| ) |  |

pure virtual

Decode a bvec of coded data.

Implemented in itpp::LDPC_Code, itpp::BCH, itpp::Dummy_Code, itpp::Convolutional_Code, itpp::Extended_Golay, itpp::Hamming_Code, itpp::Punctured_Convolutional_Code, and itpp::Reed_Solomon.

## decode() [2/4]

virtual bvec itpp::Channel_Code::decode | ( | const bvec & | coded_bits | ) |

pure virtual

Decode a bvec of coded data.

Implemented in itpp::LDPC_Code, itpp::BCH, itpp::Dummy_Code, itpp::Convolutional_Code, itpp::Extended_Golay, itpp::Hamming_Code, itpp::Punctured_Convolutional_Code, and itpp::Reed_Solomon.

## decode() [3/4]

virtual void itpp::Channel_Code::decode | ( | const vec & | received_signal,
|  | bvec & | decoded_bits
| ) |  |

pure virtual

Decode a vec of received data.

Implemented in itpp::LDPC_Code, itpp::Dummy_Code, itpp::BCH, itpp::Convolutional_Code, itpp::Extended_Golay, itpp::Hamming_Code, itpp::Punctured_Convolutional_Code, and itpp::Reed_Solomon.

## decode() [4/4]

virtual bvec itpp::Channel_Code::decode | ( | const vec & | received_signal | ) |

pure virtual

Decode a vec of received data.

Implemented in itpp::LDPC_Code, itpp::BCH, itpp::Dummy_Code, itpp::Convolutional_Code, itpp::Extended_Golay, itpp::Hamming_Code, itpp::Punctured_Convolutional_Code, and itpp::Reed_Solomon.

## get_rate()

virtual double itpp::Channel_Code::get_rate | ( |  | ) | const

pure virtual

Get the code rate.

Implemented in itpp::BCH, itpp::Dummy_Code, itpp::Extended_Golay, itpp::Hamming_Code, itpp::LDPC_Code, itpp::Punctured_Convolutional_Code, itpp::Reed_Solomon, and itpp::Convolutional_Code.

The documentation for this class was generated from the following file:

- itpp/comm/channel_code.h

Generated on Mon Apr 22 2024 09:45:27 for IT++ by Doxygen 1.9.8